/************************************************************************
 * Copyright (c) 1999 Kenneth S. Sanislo (sanislo@wolfenet.com)         *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License v2 or later.    *
 ************************************************************************/

#define VERSION "1.0"

/* Change this line to equal 0x89 for a TI-92, or 0x98 for a TI-89 */
#define TI_HEXID 0x98

#undef DEBUG
#define DEBUG

#include <stdio.h>
#include <fcntl.h>
#include <sys/time.h>
#include <sys/types.h>
#include <termios.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#define COM_VAR 0x06
#define COM_WAIT 0x09
#define COM_DATA 0x15
#define COM_OK 0x56
#define COM_CHKERR 0x5a
#define COM_TEST92 0x68
#define COM_SCRDUMP 0x6d
#define COM_CONTINUE 0x78
#define COM_DIRECT 0x87
#define COM_EOT 0x92
#define COM_REQ 0xa2
#define COM_SEND 0xc9

#define mkpkt(a, y, z) { \
     a.device = (TI_HEXID & 0x0f); \
     a.command = y; \
     a.length = z; \
}

void *load_var (char *filename, int *len, char *varname, char *folder);

static int calcfd;

static char filetypes_92[] =
  "e---l-m---ctsda-i-pfx---h----b-g-z---------------r";

typedef struct _TI_Packet
{
  unsigned char device;
  unsigned char command;
  unsigned short length;
}
TI_Packet;

typedef struct _TI_Varhead92
{
  unsigned short length;
  unsigned char junk1;
  unsigned char junk2;
  unsigned char type;
  unsigned char namelen;
}
TI_Varhead92;

typedef struct _TI_File92
{
  unsigned char magic[8];
  unsigned char sep1[2];
  unsigned char folder[8];
  unsigned char ident[40];
  unsigned char sep2[6];
  unsigned char name[8];
  unsigned char sep3[4];
  unsigned char length[4];
  unsigned char sep4[6];
}
TI_File92;

typedef struct _TI_Varjunk92
{
  unsigned char junk[4];
  unsigned char size[2];
}
TI_Varjunk92;

#define do_size(x) (x[1] << 8 | x[0])
#define rev_size(x) (x[0] << 8 | x[1])
